package com.sun.jmx.snmp.IPAcl;

import java.security.acl.LastOwnerException;
import java.security.acl.NotOwnerException;
import java.security.Principal;
import java.util.Vector;
import java.io.Serializable;
import java.security.acl.Owner;

class OwnerImpl implements Owner, Serializable
{
    private static final long serialVersionUID = -576066072046319874L;
    private Vector<Principal> ownerList;
    
    public OwnerImpl() {
        this.ownerList = null;
        this.ownerList = new Vector();
    }
    
    public OwnerImpl(PrincipalImpl obj) {
        this.ownerList = null;
        (this.ownerList = new Vector()).addElement(obj);
    }
    
    public boolean addOwner(Principal o, Principal principal) throws NotOwnerException {
        if (!this.ownerList.contains(o)) {
            throw new NotOwnerException();
        }
        if (this.ownerList.contains(principal)) {
            return false;
        }
        this.ownerList.addElement(principal);
        return true;
    }
    
    public boolean deleteOwner(Principal o, Principal principal) throws NotOwnerException, LastOwnerException {
        if (!this.ownerList.contains(o)) {
            throw new NotOwnerException();
        }
        if (!this.ownerList.contains(principal)) {
            return false;
        }
        if (this.ownerList.size() == 1) {
            throw new LastOwnerException();
        }
        this.ownerList.removeElement(principal);
        return true;
    }
    
    public boolean isOwner(Principal o) {
        return this.ownerList.contains(o);
    }
}
